
function [ betahat, shat ] = MC_Inference_LASSO ( Y, X, lambda, q )

[ NumRow, NumCol ] = size(X);
n = NumRow;
m = NumCol;

vv = zeros(NumCol,1);
XX = zeros(NumRow,NumCol);
for j = 1 : NumCol
    vv(j) = norm( X(:,j)/sqrt(n) );
    XX(:,j) = X(:,j) / vv(j) ;
end
VecLAMBDA = [ lambda ; zeros(q,1) ; lambda*ones(m-1-q,1) ];
beta_L1 =  LassoShooting_VecLAMBDA(XX,Y,VecLAMBDA);
%beta_L1 = LassoPrimalDualLogBarrier(XX,Y,lambda);
betahat = beta_L1 ./ vv;
shat = sum( ( abs(betahat) > 0 ) );

