%
%
%  Post estimator Trimms component j if \hat\sigma_j \hat\beta_j < eps
%
%
function [ betatilde, stilde, STDerror ] = MC_Inference_PostEstimator ( Y, X, beta_FS, eps, q )

[ n , p ] = size(X);

v = zeros(p,1);
for j = 1 : p 
    v(j) = norm( X(:,j) / sqrt(n) );
end

ind = ( abs(beta_FS.*v) > eps );
if( min(X(:,1))==max(X(:,1)) )
    ind(1) = 1;
end
XX = [];
ind_col = [];

for j = 1 : p 
    if ( ind(j) == 1 )
        XX = [ XX  X(:,j) ];
        ind_col = [ ind_col j ];
    end
end

K = max(size(ind_col));
betatilde = zeros(p,1);

if     ( K >= n  )
    Minv = pinv(XX'*XX);
    
elseif ( K > 0  )

    Minv = inv(XX'*XX);
        
end

if ( K > 0 )
    betatilde(ind_col) = Minv*XX'*Y;
end

stilde = K;

STDerror = zeros(1,1:q);
for j = 1 : q
    STDerror(j) = sqrt( Minv(j+1,j+1) );
end


