
%
%  Post estimator Trimms component j if \hat\sigma_j \hat\beta_j < eps
%
%
function [ betatilde, stilde ] = MC_PostLASSO_PostEstimator ( Y, X, beta_FS, eps )

[ n , p ] = size(X);

v = zeros(p,1);
for j = 1 : p 
    v(j) = norm( X(:,j) / sqrt(n) );
end

ind = ( abs(beta_FS.*v) > eps );
XX = [];
ind_col = [];

for j = 1 : p 
    if ( ind(j) == 1 )
        XX = [ XX  X(:,j) ];
        ind_col = [ ind_col j ];
    end
end

K = max(size(ind_col));
betatilde = zeros(p,1);

if     ( K >= n  )
    
    betatilde(ind_col) = pinv(XX'*XX)*XX'*Y;
    
elseif ( K > 0  )

    betatilde(ind_col) = inv(XX'*XX)*XX'*Y;

end

stilde = K;